"nodejs";
import $JavaArray from "./createJavaArray.mjs";

var class_array;

//使用fromTypeAndLength方法创建长度为5的空float数组
class_array = $JavaArray.fromTypeAndLength("float", 5);
//赋值前两位元素
class_array[0] = 180;
class_array[1] = 1.378;
//打印数组本身与长度
console.log(class_array, class_array.length);
//循环打印数组元素
for (let i = 0; i < class_array.length; i++){
    console.log(class_array[i]);
}


//使用fromArray自动识别类型与长度，创建类型数组与填充
class_array = $JavaArray.fromArray([
    1.0,
    2.6,
    7.9
]);
/*
*fromArgs与fromArray功能一致，但不需要在元素外套一个数组
*class_array = $JavaArray.fromArray(1.0, 2.6, 7.9);
*/
//打印数组本身与长度
console.log(class_array, class_array.length);
//循环打印数组元素
for (let i = 0; i < class_array.length; i++){
    console.log(class_array[i]);
}


/*
*js中的部分原始类型会自动转换为java原始类型或类实例
*布尔值: boolean，整数: int，浮点数: double，字符串: java.lang.String
*由于js中无法分辨1.0与1的区别，所以1.0会被识别为int类型
*类似的情况下可以使用fromTypeAndArray与fromTypeAndArgs手动指定类型
*/
class_array = $JavaArray.fromTypeAndArray("float", [
    1.0,
    2.6,
    7.9
]);

//打印数组本身与长度
console.log(class_array, class_array.length);
//循环打印数组元素
for (let i = 0; i < class_array.length; i++){
    console.log(class_array[i]);
}


/*
*fromTypeAndLength、fromTypeAndArray与fromTypeAndArgs的首位参数可为以下内容:
*java原始类型字符串: "boolean", "int", "long", "double", "char", "byte", float"
*java类或类名: java.lang.String, "java.io.File"
*java类实例: new java.lang.StringBuffer()
*js部分原始类型值: 布尔值: boolean，整数: int，浮点数: double，字符串: java.lang.String
*/
class_array = $JavaArray.fromTypeAndLength("int", 5);
//打印数组本身与长度
console.log(class_array, class_array.length);

class_array = $JavaArray.fromTypeAndLength(java.lang.String, 5);
//打印数组本身与长度
console.log(class_array, class_array.length);

class_array = $JavaArray.fromTypeAndLength("java.io.File", 5);
//打印数组本身与长度
console.log(class_array, class_array.length);

class_array = $JavaArray.fromTypeAndLength(new java.lang.StringBuffer(), 5);
//打印数组本身与长度
console.log(class_array, class_array.length);


//多维数组的创建
class_array = $JavaArray.fromTypeAndLength("int", [1, 2]);
//打印数组本身与长度
console.log(class_array, class_array.length);

class_array = $JavaArray.fromArray("float", [
    [1, 150]
]);
//打印数组本身与长度
console.log(class_array, class_array.length);

class_array = $JavaArray.fromTypeAndArgs("float", [1, 150]);
//打印数组本身与长度
console.log(class_array, class_array.length);